---
title: ExtendableMessageEvent()
slug: Web/API/ExtendableMessageEvent/ExtendableMessageEvent
tags:
  - API
  - Constructor
  - Experimental
  - ExtendableMessageEvent
  - Reference
  - Service Workers
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <code><strong>Extendable</strong></code><strong><code>MessageEvent()</code></strong> constructor creates a new {{domxref("ExtendableMessageEvent")}} object instance.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>extendableMessageEvent</em> = new ExtendableMessageEvent(<em>type</em>, <em>init</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>type</dt>
 <dd>A {{domxref("DOMString")}} that defines the type of the message event being created.</dd>
 <dt>init {{optional_inline}}</dt>
 <dd>An initialisation object, which should contain the following parameters:
 <ul>
  <li><code>data</code>: The event's data — this can be any data type.</li>
  <li><code>origin</code>: A {{domxref("DOMString")}} that defines the origin of the corresponding service worker's environment settings object.</li>
  <li><code>lastEventId</code>: A {{domxref("DOMString")}} that defines the last event ID of the event source.</li>
  <li><code>source</code>: The {{domxref("Client")}}, {{domxref("ServiceWorker")}} or {{domxref("MessagePort")}} that sent the message.</li>
  <li><code>ports</code>: An array containing the {{domxref("MessagePort")}} objects connected to the channel sending the message.</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">var init = {
             data : 'hello message',
             source : MessagePortReference,
             ports : MessagePortListReference
           }

var myEME = new ExtendableMessageEvent('message', init);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-extendablemessageevent-extendablemessageevent', 'ExtendableMessageEvent()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ExtendableMessageEvent.ExtendableMessageEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging</a></li>
</ul>
